# -*- coding: utf-8 -*-
# Copyright 2009-2017 Noviat.
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl).
from datetime import datetime
from .test_common import TestCommon


class TestOpenInvoices(TestCommon):

    def _getReportModel(self):
        return 'aged.open.invoices.webkit'

    def _getReportName(self):
        return 'account.account_aged_open_invoices_webkit'

    def _getBaseFilters(self):
        return {'until_date': '%s-12-31' % (datetime.now().year)}

    def test_common(self):
        common_tests = [
            x for x in dir(self)
            if callable(getattr(self, x)) and x.startswith('common_test_')]
        for test in common_tests:
            getattr(self, test)()
